#ifndef THDUALSPRITES_H
#define THDUALSPRITES_H

#include <PA9.h>

#define THMAXVSPRITES	512		//max virutal sprites (dual screen ones)

#define THMAXSPRITES 125	//using the top 8 for player and high priority crap??

struct thSprite_s {
	void *sprite;
	u8 shapex;
	u8 shapey;
	u8 pal;
	signed char priority;		//what priority level 
	signed char hwsprite0;	//actual hw sprite im using on this screen
	signed char hwsprite1;	// ohh ya i almost forgot sometimes we need to be 2 places at once :D
	int rotset;
	int screen;	//last screen i used.... (or -1 for invisible)
	u8 size;	
	u8 used;		//if used >1 then indicate priority?
	u8 alpha;	//enable alpha blending?

};


inline int thSpriteChk(int x, int y, u8 size);
inline int thGetNextSprite(u8 screen);
void thSpriteDiag(void);

void thSpriteInit(void);
int thSpriteCreate(void *sprite, u8 shapex, u8 shapey, int size, u8 pal,int x, int y, int rotset, signed char priority);
void thSpriteSetAlpha(int spriteh, unsigned char alpha);
int thSpriteSetXY(int spriteh, int x, int y);
int thSpriteDestroy(int spriteh);
void thSpriteUpdateGfx(int spriteh,void *obj);
void thSpriteUpdateRotset(int spriteh,int rot);
void thSpriteUpdatePal(int spriteh, u8 pal);
void thSpriteUpdateGfxPal(int spriteh,void *obj,u8 pal);

//Rotation set pool functions
#define ROTSETMAX 30	//how many rotsets (for static rotsets start at top and work down :P)

struct brot_s {
	int spd;	//what speed to use
	u32 angle;	//what angle to start at
	u8  used;	
};

extern struct brot_s throts[ROTSETMAX];

void rotsetInit(void);
void rotsetUpdate();
u8 rotsetCreate(int spd, u32 angle); //create and retrun a rotset from pool
void rotsetDestroy(u8 rotset);

#endif
