/************************************************************************
 thgoodness.c - mostly the core game stuffs
	thds01 the damaku sequencer with modular pattern synthisizers. 
*************************************************************************/


#include <PA9.h>
#include "thgoodness.h"
#include "thbullets.h"
//sounds & gfx
#include "menuselect.h"
#include "thdualsprites.h"
//#include "piano.h"

#include "marisaspells.h" //this is ony to get her grimoire for test...

#include "gfx/all_gfx.h"
#include "thentities.h"
#include "thmenu.h" //for the music room defines
#include "scenarioscript.h"
#include "death.h"
#include "thsound.h"
#include "thdialog.h"

//this should be assemilated into the gamestateflags thingy

u32 timeLived;	//how long the player's been alive
u32 gameFlags;

//instantiate the player
struct sPlayer player;

struct bsprite_s thplyr16={OBJ_SIZE_16X16,PLYRPAL,16,4}; //this could be global i guess
struct bsprite_s thplyr32={OBJ_SIZE_32X32,PLYRPAL,32,8}; //this could be global i guess

//shouldnt these be in the bullets file?? (more like are they even used anymore?)
int brotset0;
int brotset1;


//used to detect player hitting spell bomb after being hit (will be set to what frame she used it on)
u32 lastspellframe;

int currentbg;


//This scrolls and updates the bg
void thDualVBLScroll(int frame) {
  if(currentbg!=-1) ((_pBgUpdateFunc)backgrounds[currentbg].update)(frame);	//update background
  PA_WaitForVBL();
}

//#define PLYRSP	126	//Sprite to use for player (and +1 = playerbg)
#define PLYRRS	31	//player's rotset


//bitmasks to store/retrieve button data from replay struct
#define RPFIRE	0x2000
#define RPFOCUS	0x4000
#define RPSPELL	0x8000
#define RPMASK	0xf000

//to store change in replay value? 
struct replayEvent {
	u8 frame;	//what frame did changes occur at? (relative to previous event that is, no event for 256 frames just sends current loc again)
//	u32 data;	//more efficient and less picky about compiler ?
	u8 x;		//0-255 player x position
	u16 y;		//0-392 (actually 512 but jaja...) 3 msb are buttons RPFIRE,RPFOCUS,RPSPELL
} __attribute__((__packed__));;

u16 oldrval;

#define RPDATAMAX 0x3000

struct replayEvent replaydata[RPDATAMAX];

//last x and y variable, used to see if player's position has changed (for replays)
int lx;
int ly;
int lt;	//frames ago

//u32 rpevents=0;	//just to count em' for now...

int replaydatacnt=0;

void thPlayerCreate(Character *playerchr) {
	//Load the pallet (note 

	//Create the sprite
	player.x=128;
	player.y=300;
	player.sx=(player.x)<<8;
	player.sy=(player.y)<<8; //subvalues (for fixed point)
	player.speed=700; //should these values be fixed point?
	player.fspeed=310;
	player.hitsz=3;		//Hitbox size
	player.grazesz=23; 	//grazebox size
	player.score=0;		//player's score
	player.graze=0;		//graze points
	player.bonus=0;
	player.time=0;		//time points
	player.lives=5;
	player.spells=5;	//give her 5 spells to start
	player.rotset=rotsetCreate(-500,0);
	player.firedly=0;
	player.spellbonus=0;
	player.invcnt=0;
	replaydatacnt=0;
	PA_DualLoadSpritePal(PLYRPAL,(void*)playerchr->pallet);
	thEntitySummon(0,playerchr,128,220);	//will be player (eventually)
	lx=0;
	ly=0;
	lt=0;	//frames ago
}

//Callback to player hit detection
unsigned char thPlayerHit(unsigned int *frame) {
	timeLived=0; //reset how long i been alive
	gameFlags|=GFLAGS_PHASDIED;
//					PA_OutputText(0, 0,15, "%d         ",who);
//						bulletsHalt(60);
	if(!player.invcnt) {
		player.invcnt=40+PA_RandMax(30);	//amount of time player will be invincible after spell (or death!)
		PA_StopSound(9);
		PA_PlaySound(9, death,(u32)death_size,109,22050);
		PA_SetSoundChannelPan(9, (u8)player.x>>1);
		*frame=thDelay(*frame,60); //Pause the game for a bit
		if(!lastspellframe) {	//this is a bit rediculous but guess itll do for now
			bulletsDestroyAllNonSticky(); //bypass these if player has hit lastspell
			if(--player.lives<0)
				return(1);
		}
	}
	return(0);
}

//called each frame to update player
int thPlayerUpdate(u32 frame, Character *plyrchr) {
	s32 xc,yc;
	u16 tbb=0;	//temporary button buffer (to store states of buttons ofc)
	struct badv_s badv={-1,3,0,NULL,0,-1}; // create advanced options bullet create struct (this one should be static or a member of player. struct

	if(player.invcnt) 	//player invincible (spellcard trance)
		player.invcnt--;
	if(player.firedly) 
		player.firedly--;

	if(Pad.Held.X || Pad.Held.R) { //focused!
		tbb|=RPFOCUS;	//yes they has pushed focus
	}
	if((Pad.Held.A || Pad.Held.L)) { //fires!
		tbb|=RPFIRE;
	}
	if ((Pad.Newpress.B || lastspellframe) && player.spells) { //spellbombs
		tbb|=RPSPELL;
	}

	if(gameFlags&GFLAGS_ISREPLAY) {
		if(--lt<=0) {
			lt=replaydata[replaydatacnt+1].frame; //find next frame
			player.sx=replaydata[replaydatacnt].x<<8;
			tbb=replaydata[replaydatacnt].y&RPMASK;
			player.sy=(replaydata[replaydatacnt].y&(~RPMASK))<<8 ;
			replaydatacnt++;
			PA_OutputText(1,0,4,"rpevnts: %d ramused: %d frame: %d",replaydatacnt,replaydatacnt*sizeof(struct replayEvent),lt);
		}
	} else {
		// Update the position according to the keypad...
		if(tbb&RPFOCUS) { //focused!
			//wasteful here...
			player.sx += Pad.Held.Right*plyrchr->fspeed - Pad.Held.Left*plyrchr->fspeed;
			player.sy += Pad.Held.Down*plyrchr->fspeed - Pad.Held.Up*plyrchr->fspeed;
			player.focused=1;
		} else {
			//note only update these IF they changed ~_~
			player.sx += Pad.Held.Right*plyrchr->speed - Pad.Held.Left*plyrchr->speed;
			player.sy += Pad.Held.Down*plyrchr->speed - Pad.Held.Up*plyrchr->speed;
			player.focused=0;
		}
		if(player.sx >65536) player.sx=65536;
		if(player.sx <0) player.sx=0;
		if(player.sy>98304) player.sy=98304;
		if(player.sy<0) player.sy=0;
		if(Stylus.Held) { //check for stylus use
			player.sx=Stylus.X<<8;
			player.sy=(Stylus.Y+192)<<8;
		}
	}
	//update player screen position
	xc=(player.x=player.sx>>8)-32;
	yc=(player.y=player.sy>>8)-32;
	thEntitySetX(0,xc);
	thEntitySetY(0,yc);
	//fire!
	if((tbb&RPFIRE) && !(player.firedly)) {
		xc=player.x;
		yc=player.y;
		if(tbb&RPFOCUS) {	//focused ? (also checked above in speed movement thingy
			bulletCreate((void*)plyrchr->bullets, &thplyr32, xc, yc-8, 0,-1700, -1,NULL,NULL,0,0);
			bulletCreate((void*)plyrchr->bullets, &thplyr32, xc-10, yc-8, -220,-1700, -1,&badv,NULL,0,0);
			bulletCreate((void*)plyrchr->bullets, &thplyr32, xc+10, yc-8, 220,-1700, -1,&badv,NULL,0,0);
			player.firedly=20;
			
		} else {
			bulletCreate(plyrchr->bullets, &thplyr32, xc, yc-8, 0,-1700, -1,NULL,NULL,0,0);
			player.firedly=7;

		}
	}			
	//spell bomb!
	if (tbb&RPSPELL) {
		if(lastspellframe) {
			player.spells-=2;
		} else {
			player.spells--;
		}
		lastspellframe=0;
		player.invcnt=80+PA_RandMax(30);	//amount of time player will be invincible after spell
		thSpellCast(0, 0); //cast spell 0 on entity 0
		gameFlags|=GLFAGS_PHASBOMB; //take away their bonus if on a spellgroup
	}
	//change gfx of girl (haxy way atm)
	if(tbb&RPFOCUS) { //focused (change gfx, seperate cause of replay may or may not call the above one)
		thSpriteUpdateGfx(0,(void*)plyrchr->fgsprite+0x1000);
	} else {
		thSpriteUpdateGfx(0,(void*)plyrchr->fgsprite);
	}
	//check for x,y,button changes...
        tbb|=(player.y&0x1ff);	//limit player y from 0-512 and tack on button infos
	//check to change states for replay events...
	if(!(gameFlags&GFLAGS_ISREPLAY)  && (((player.x!=lx) || (tbb!=ly)) || ((frame-lt)==255))) { //if not replay then update
		lx=player.x;
		ly=tbb;
		//need to record lx, ly, and frame-lt now!! damn distractions >_>
//		rpevents++; //increment this for now... i wanna see how much ram this is gonna use...
		if(replaydatacnt<RPDATAMAX) {
			replaydata[replaydatacnt].frame=frame-lt;
			replaydata[replaydatacnt].x=player.x;
			replaydata[replaydatacnt].y=tbb;
			replaydatacnt++;
			PA_OutputText(1,0,4,"rpevnts: %d ramused: %d frame: %d",replaydatacnt,replaydatacnt*sizeof(struct replayEvent),frame-lt);
			lt=frame;
		}
	}
	PA_DualSetRotsetNoZoom(PLYRRS, // rotset
		   (frame<<2)&511); // angle, from 0 to 511
	PA_OutputText(1, 2,0, "Score: %d  Graze: %d    ",player.score,player.graze);
	PA_OutputText(1, 1,1, "Lives: %d  Spells: %d Bonus: %d   ",player.lives,player.spells, player.bonus>>8);
	return 0;
}





u32 splbeattime;


// u know.. dialog COULD be done as a spell... but hmmmz doubt zun does it that way considering the appearance. the advantage would be its easy to create a blank spell that does the dialog updates... hmmmz could use both dunno this works for now eheh
void thEraseTxtArea(int screen, char xa, char ya, char xb, char yb) {
	char x=xa;
	do {
		do {
			 PA_SetTileLetter(screen, x, ya, ' ');
		} while(++x<=xb);
		x=xa;
	} while(++ya<=yb);
}


//and the level description
int thStage(struct StageSteps *steps, Character *playerchr,const char *desc, void *stagesprite) { //within here is the actual game loop?
	//First initalize everything i guess, then start running thru the steps!
	u32 frame=0;	//frame counter
	s8 fps = 0; //Our FPS
	s8 time = 0;
	s8 lastTime = 0;
	struct badv_s badv={-1,STAGEDESCTIME,0,NULL,0,0,0}; // create advanced options bullet create struct
	struct bsprite_s bullshit={OBJ_SIZE_64X32,MENUTXTPAL,64,0}; //this magicBullet could be global i guess
	int stepndx=0;
	int nextframe=0;
	int erasedesc=0; 	//lame hax to deal with erasing the screen...
	char dialogRunning=0;
	int splgrptime=0;	//so many vars here ~_~
	currentbg=-1;
	gameFlags=0;
	lastspellframe=0;
	//more fps code from example
	lastTime = PA_RTC.Seconds; 
	//We may start halfway into a second
	//let's wait until the clock starts the next second
	while(PA_RTC.Seconds == lastTime) {
	   	PA_WaitForVBL();
	}
	lastTime = PA_RTC.Seconds; 
	thSpriteInit();
	bulletInit();	//Initalize danmaku engine
	thEntityInit();

	if(replaydatacnt) {
		gameFlags|=GFLAGS_ISREPLAY;
		RandomValue=oldrval;
	} else {
		oldrval=RandomValue;
	}
		

	thPlayerCreate(playerchr);
	thSpellsInit(); 
//	entityDied=0;
       	PA_OutputText(0,21,22,"     %dfps",60);  	
	while(1){ // Main loop
		if(nextframe>=0) {
			if(nextframe<=frame) {
				do {
					if(steps[stepndx].type==STAGE_BG) {
//						bg1Setup();
						currentbg=steps[stepndx].index;
						((_pBgSetupFunc)backgrounds[currentbg].setup)();
					} else if(steps[stepndx].type==STAGE_BGM) {
						thEraseTxtArea(0,0, 21, 30, 21);
						PA_OutputText(0, 0,21, "BGM: %s",playSong(musicList, steps[stepndx].index));
					} else if(steps[stepndx].type==STAGE_BGMSTOP) {
						PA_StopMod(); 
						PA_StopSound(8);
					} else if(steps[stepndx].type==STAGE_SPELLCAST) {
						thSpellCast(steps[stepndx].entity, steps[stepndx].index);
					} else if(steps[stepndx].type==STAGE_SUMMON) {
						if(steps[stepndx].chr->class==CCLASS_BOSS)
							PA_DualLoadSpritePal(BOSSPAL,steps[stepndx].chr->pallet  );	//For bosses load pallet
							thEntitySummon(steps[stepndx].entity, steps[stepndx].chr,steps[stepndx].x,steps[stepndx].y);
					} else if(steps[stepndx].type==STAGE_BANISH) {
						thEntityBanish(steps[stepndx].entity);
					} else if(steps[stepndx].type==STAGE_DIALOG) {
						gameFlags|=GFLAGS_PSAFE; //keep the player safe
						thDialogStart(steps[stepndx].chr->dialog[steps[stepndx].index]);	//ok this should startup dialog
						dialogRunning=1;
					} else if(steps[stepndx].type==STAGE_SETGFLAGS) {
						gameFlags|=steps[stepndx].index; 
					} else if(steps[stepndx].type==STAGE_SHOWLVL) {
						bulletCreate(stagesprite, &bullshit, 40, 245, -512, 0, -1,&badv,NULL,0,0);
						erasedesc=STAGEDESCTIME-10;
					} else if(steps[stepndx].type==STAGE_SPELLPAUSE) {
						thSpellPause(steps[stepndx].entity);						
					} else if(steps[stepndx].type==STAGE_SPELLRESUME) {
						thSpellResume(steps[stepndx].entity);						
					} else if(steps[stepndx].type==STAGE_ENTITYSTOP) {
						thSpellStopMovement(steps[stepndx].entity);	
					} else if(steps[stepndx].type==STAGE_ENTITYMOVE) {
						thEntityMove(steps[stepndx].entity,steps[stepndx].x,steps[stepndx].y,steps[stepndx].index);
					} else if(steps[stepndx].type==STAGE_SETHEALTH) {
						thEntitySetHealth(steps[stepndx].entity,steps[stepndx].index<<8);	
					} else if(steps[stepndx].type==STAGE_STRTSPLGRP) {
						gameFlags&=(GFLAGS_PHASDIED|GLFAGS_PHASBOMB|GFLAGS_HIDEHEALTH)^0xffffffff;
						splgrptime=frame;
						splbeattime=0;
						thEntitySetHealth(1,100<<8);	//set boss's health up to 100% (boss is always entity1)
					} else if(steps[stepndx].type==STAGE_ENDSPLGRP) {
						if(!((gameFlags&GFLAGS_PHASDIED) || (gameFlags&GLFAGS_PHASBOMB))) {
//player should get bonus for completing spell without dying, without using bombs, and even more if she got enemy's health to 0!
							player.spellbonus+=(frame-splgrptime)*1024; //time 
							PA_OutputText(0, 0,6, " Spell Survival Bonus: %d  ",player.spellbonus);
						} 

						if(splbeattime) {
							player.spellbonus+=(frame-splbeattime)*2008; //shorter it took u to beat her better ur points
							PA_OutputText(0, 0,7, " Spell Complete Bonus: %d  ",(frame-splbeattime)*2008);
						}
//else {
//							PA_OutputText(0, 2,16, " Spell Bonus Failed  ",player.bonus>>8);
//						}
						erasedesc=STAGEDESCTIME-74; //hax hax ://
					} else if(steps[stepndx].type==STAGE_FINISH) {
						thGameOver(frame); //should be Stage over
						return(0);
					} else if(steps[stepndx].type==STAGE_CLEARGFLAGS) {
						gameFlags&=(steps[stepndx].index^0xffffffff);
					} else if(steps[stepndx].type==STAGE_BOSSDEATH) { //initiate boss death sequence... note its left up to script to actually get rid of boss as they may need to remain for theatrical purposes...
						thSpellCast(steps[stepndx].entity, 0); //spell 0 is death spell for bosses
						bulletsDestroyAllFollow(steps[stepndx].entity); //go ahead and take out their familiars first
					}
					if(steps[stepndx].type==STAGE_HALT) { // wait2die
						nextframe=-1;
					} else {
						nextframe=frame+steps[stepndx].wait;
					}
					stepndx++;
	//		thDelay(0,30);
				} while(steps[stepndx-1].wait==0);

			}
		} else {
//			PA_OutputText(0, 2,6, "waiting....   %d",entityDied);
/*			if(entityDied) {
				entityDied=0;
				nextframe=frame+steps[stepndx].wait;
				bulletsDestroyAllSize(32);
				bulletsReplaceAllSizeDrop((void*)bbox_Sprite, 16, -2,FAMPAL);

			};
*/
		}
		if(dialogRunning) {
			if(!(Pad.Released.A)) {
				if(!(dialogRunning=thDialogUpdate())) {
					nextframe=frame+steps[stepndx].wait;
				}
			}
		} else {
			player.score+=1; //increase player's score just for still being alive :P
		}	


//diag line for stages...
//			PA_OutputText(0, 2,6, "step: %d frame: %d  Nextframe: %d  ",stepndx, frame,nextframe);

// okie we set dialog running to 1 call thDialogStart() and voila!


//		PA_OutputText(0, 2,5, "next:%d cur: %d    ",nextframe,frame);
		if(erasedesc==STAGEDESCTIME-73)	PA_OutputText(0, 6,6, "%s    ",desc);
		//even lamer begining programmer technique or line erasing >_> fix this !!!
		if(--erasedesc==0)	{
			thEraseTxtArea(0,0, 6, 30, 10);
		}
		
		if((thEntityUpdate(&frame)!=0) || Pad.Released.Start) {
			break;	//if player lost break this loop!
		}
		bulletUpdate();
		rotsetUpdate();
		//i dislike all these -1 but is usually +1 instructions or more vs ==0 or !=0 :/
		///ooo fastfwd :P
		if(!Pad.Held.Select) thDualVBLScroll(frame);
		thPlayerUpdate(frame,playerchr);					//Note it should Really call shutdown functs from each lib
//	thSpriteDiag();
//		if(frame==200) {

		frame++; //this is sorta redundant to scroll?
			//borrowed this handy code from the palib example :P
		      	fps +=1;  //up the fps every time the code runs through
		      	time = PA_RTC.Seconds;  //Grab the time		      
		      	//If the second has changed we are done counting frames
		      	if(time != lastTime)
		     	{
		         	lastTime = time;  //Start looking for end of next second
		         	PA_OutputText(0,21,22,"     %dfps   ",fps);  	
		         	fps = 0;	 //Start counting back at zero
		      	}  
//		if(Pad.Newpress.Y) {
//			PA_StopSound(8);
//			PA_StopMod();
//		}
	}
	thGameOver(frame); //should be Stage over
	return(0);
}

// this would be called by start game
int thScenarioStart(struct Stage *scenario, Character *player) {
	PA_ClearTextBg(0);
	PA_ClearTextBg(1);
	return(thStage(scenario[0].steps,player,scenario->text,scenario->sprite));
}
//Most of this and the next loop should be in thgoodness's gameStart()
void thGameStart(u8 player, u8 difficulty, u8 spell, u8 flags) {
	brotset0=rotsetCreate(-500,0);
	brotset1=rotsetCreate(500,0);
	thScenarioStart(ezScenario,&bluemarisachr);
}

//delay this many frames (and keep up the parallax !) (obsolete! needs to be integrated with the new backgrounds table)
u32 thDelay(u32 frame, u32 dly) {
	int retfr=dly+frame;
	 while(frame<retfr) {
		frame++;
		thDualVBLScroll(frame);
		if (Pad.Newpress.B && (player.spells>1)) { //lastspell activated and player has at least 2 spells?
			lastspellframe=frame;		
			return frame;	//cut it short 
		}
	};
	return frame;
}

//or better yet mod the pallet! (considering the fade fx here)
// hmmz @ #define PA_Clear8bitBg(screen) DMA_Copy(Blank, (void*)PA_DrawBg[screen], 256*96, DMA_16NOW);
void thGameOver(u32 frame) {
	int c;
	int endframe=frame;
//	frame=thDelay(frame,80);
	c=256;
	do { //fade out audio (should do that touhou fade to white effect) oh wth u cant set bg pixels?!?
			//ohh i hafta init it with draw16bit or something grrr stupid!
			//should prolly make my own lowlevel gfx functions..
		frame++;
		thDualVBLScroll(frame);
		PA_SetSoundChannelVol(8, c>>1);
	} while(--c!=0);
//	frame=thDelay(frame,10);
//	PA_DualDeleteSprite(PLYRSP);
//	bulletsHalt(00);
	bulletsDestroyAll();
	PA_StopSound(8);
	PA_ClearTextBg(0);
	PA_ClearTextBg(1);

	PA_OutputText(0, 2,3, "     Total Score: %d  ",player.score+player.spellbonus+(player.graze*(player.bonus>>2))+player.spellbonus);
	PA_OutputText(0, 2,4, "           Final: %d  ",player.score);	
	PA_OutputText(0, 2,5, "           Bonus: %d  ",player.graze*(player.bonus>>2));	
	PA_OutputText(0, 2,6, "     Spell Bonus: %d  ",player.spellbonus);
	PA_OutputText(0, 2,7, " Bonus collected: %d  ",player.bonus>>8);
	PA_OutputText(0, 2,8, "     Graze total: %d  ",player.graze);
//	PA_OutputText(0, 2,8, "Completed Spells: %d  ",thSpellsCompleted-1);
	PA_OutputText(0, 2,9, "   Game Duration: %d sec.",endframe/60);
	PA_OutputText(0, 0,22, " press fire to continue...");
	while(!(Pad.Released.A || Pad.Released.L)) {
		frame++;
		thDualVBLScroll(frame);
	}
	PA_DeleteBg(0,1);
	PA_DeleteBg(0,2);
	PA_DeleteBg(0,3);
	PA_DeleteBg(1,1);
	PA_DeleteBg(1,2);
	PA_DeleteBg(1,3);
}
