/*********************************************
 thmenu.c - menu and other common th stuffs
**********************************************/

#include <PA9.h>
#include "thmenu.h"
#include "gfx/all_gfx.h"
//mod includes (this system is lame y0! learn to link frill pplz!!)
#include "menuselect.h"
#include "menuscroll.h"

#include "thdualsprites.h"
#include "thbullets.h"
//#include "piano.h"	//for now ok
#include "thsound.h"

#define TXTCOLR TEXT_WHITE

//If someone clicks between Ya and Yb area of touchscreen it figures out with Division of that distastace it falls in
//sometimes i sux at descriptions :/
//returns a non negative value if the touchscreen is being pushed 
int menuGetScreenY(int ya, int yb, int div) {
	if(Stylus.Released && (Stylus.Y>=ya) && (Stylus.Y<=yb)) {
		return(Stylus.Y-ya)/div;
	}
	return(-1);	//EZ!
}


//display results
void menu_stats(void) {	
	return; 
}

//Display the music menu
void menuMusicfunct(void) {
	int item=0;
	int numitems=0;
	struct thMenuItems *menuitems;
	while(musicList[numitems].name) {	//count music list items
		numitems++;
	};
	menuitems=malloc((numitems+2)*sizeof(struct thMenuItems));	//alloc space for temporary music menu + quit and end markers
	bzero(&menuitems[numitems+1],sizeof(struct thMenuItems));	//NULL out last one
	menuitems[numitems].name="Quit";
	menuitems[numitems].type=MENU_END;
	do {
		menuitems[item].name=musicList[item].name;
		menuitems[item].type=MENU_EXIT;
	} while(++item!=numitems);
	item=0;
	while(1) {
		item=menuSelect(menuitems,2,2,item);
		if(item>=0) {
			playSong(musicList,item);
		} else {
			break;
		}
	}
	free(menuitems);
}


const struct thMenuItemGfx menuMain[] = {
	{(void*)startgfx_Sprite,MENU_EXIT,NULL},	//Choose Girl
	{(void*)musicroomgfx_Sprite,MENU_FUNC,(void*)&menuMusicfunct},
	{(void*)resultsgfx_Sprite,MENU_FUNC,(void*)&menu_stats},
	{(void*)NULL,MENU_END,NULL}	

};


/*
* menuClear clears the menu screen of text, wtf isnt this built in?
*/

void menuClear(void) {
//	int c=0;
	//i has a better way of doing this now!
	thEraseTxtArea(0, 0, 0, 30,23);
//	do {
//		PA_OutputSimpleText(0,0,c,"                                     ");
//	} while(++c<23);
}

/*
*   menuSelect(which menu, menu start pos x, startpos y, default item to be selected)
*/
int menuSelect(struct thMenuItems *menu, char x, char y, int ndx) {
	int c;
	int max=0;
	int touchval=-1;
	while(1) {
		menuClear();
		//print menu
		PA_SetTextTileCol(0, TXTCOLR);
		c=0;
		while(menu[c].name) {
			PA_OutputText(0, x, y+c, "%s  ",menu[c].name);
			max=c++;	//figure out last menu item
		}
		while(1) {
			PA_SetTextTileCol(0, TEXT_RED);
			PA_OutputText(0, x, y+ndx, "%s    ",menu[ndx].name);
			PA_CheckLid();		//also these need to be here or else itll loop on keypress
			PA_WaitForVBL();	//These two should be combined into one function
			if(Pad.Released.A  || (touchval>=0)) { //go to next menu?
				PA_PlaySimpleSound(9, menuselect);
				if(menu[ndx].type==MENU_MENU) { //display a submenu
					menuSelect(menu[ndx].location,x,y,0);
					break;
				} else if(menu[ndx].type==MENU_EXIT) {
					menuClear();
					return(ndx);
				} else if(menu[ndx].type==MENU_END) {
					menuClear();
					return(-1);
				} else if(menu[ndx].type==MENU_FUNC) {
					((_pMENU)menu[ndx].location)(); //call a function
					break;
				}
			}
			if(Pad.Newpress.X) { //Press X to stop mod! (it gets annoying) :P
				PA_StopMod();
			}
			if((touchval=menuGetScreenY((y)<<3, ((y)+(max+1))<<3, 8))>=0) {
				ndx=touchval;
			}

			if(Pad.Newpress.Up || Pad.Newpress.Down || (touchval>=0)) {
				PA_SetTextTileCol(0, TXTCOLR);
				PA_OutputText(0, x, y+ndx, "%s  ",menu[ndx].name);
				PA_PlaySimpleSound(9, menuscroll);
				if(touchval<00) {
					if(Pad.Newpress.Up) {
						if(--ndx<0) ndx=max;
					} else {
						if(++ndx>max) ndx=0;
					}
				}
			}
		}
	}
}



/*
*   menuSelectgfc(which menu, menu start pos x, startpos y, default item to be selected)
*/
int menuSelectGfx(const struct thMenuItemGfx *menu, char x, char y, int ndx) {
	int c;
	int max=0;
	int bulls0[6];	//to store our bullet handles
	int bulls1[6];	//to store our followed bullet handles (for second part of txt)
	struct bsprite_s menubull={OBJ_SIZE_64X32,MENUTXTPAL,64,0}; //this magicBullet could be global i guess
	struct badv_s badv={-1,0,30,NULL,0,-1,1}; // create advanced options bullet create struct default to alpha blending
	int touchval=-1;
	int xa=0;
	int xcnt;
	int fps=0;
	int time=0;
	int lastTime=0;
	thSpriteInit();
	bulletInit();	//Initalize danmaku engine
	y+=192;
	while(1) {
		xcnt=0;
		menuClear();
		//print menu
//		PA_SetTextTileCol(0, TXTCOLR);
		c=0;
		while(menu[c].sprite) {	//create menu sprites
			//create both halves of the thing, and using my bullet's system thingy it should follow each other
			if(c&1) {
				xa=x+PA_RandMax(10)+5; 
//				xs=-(20+PA_RandMax(20));
			} else {
				xa=x-(PA_RandMax(10)+5); 
//				xs=20+PA_RandMax(20);
			}
			badv.msdly=30;
//		if(c==0) badv.alpha=0; else badv.alpha=1;
			badv.follow=(bulls0[c]=bulletCreate(menu[c].sprite, &menubull, xa, y+(c*40), 0,0, -1,&badv,NULL,0,0)); 

			bulls1[c]=bulletCreate(menu[c].sprite+2048, &menubull, xa, y+(c*40), 64,0, -1, &badv, NULL, BULLET_FOLLOW, 0);
//			PA_OutputText(0, 4, 5, "%d    ",badv.follow);
			max=c++;	//figure out last menu item
		}
		bulletsSetAlpha(bulls0[ndx],0);	// turn on alpha 
		bulletsSetAlpha(bulls1[ndx],0);	// turn on alpha 
		 // if at two points move bullets one way then the next ie ==100 move this way, ==0 move other way and reset
		while(1) {
			//move the words a bit every few seconds...
			if(xcnt==605) {
				c=0;
				do {
				if(c&1) {
					xa=0	; 
					xa=96-PA_RandMax(50);
				} else {
				xa=PA_RandMax(50)+96;
				}

					bulletsSetVector(bulls0[c], xa,  y+(c*40),500); //move me further from home D:
					bulletsSetMSdly(bulls0[c],120);
				} while(menu[++c].sprite);
			 	xcnt=-100;;

			}
			if(xcnt==00 ) {
				c=0;
				do {
					bulletsSetVector( bulls0[c],96,  y+(c*40),100); //move me closer to home :D
					bulletsSetMSdly(bulls0[c],90);

				} while(menu[++c].sprite);
			}
			
			xcnt++;
			bulletUpdate();

			//borrowed this handy code from the palib example :P
		      	fps +=1;  //up the fps every time the code runs through
		      	time = PA_RTC.Seconds;  //Grab the time		      
		      	//If the second has changed we are done counting frames
		      	if(time != lastTime)
		     	{
		         	lastTime = time;  //Start looking for end of next second
		         	PA_OutputText(0,21,22,"     %dfps   ",fps);  	
		         	fps = 0;	 //Start counting back at zero
		      	}  
			PA_CheckLid();		//also these need to be here or else itll loop on keypress
			PA_WaitForVBL();	//These two should be combined into one function
			if(Pad.Released.A || (touchval>=0)) { //go to next menu?
				touchval=-1;	//after detecting this destroy it
				PA_PlaySimpleSound(9, menuselect);
				if(menu[ndx].type==MENU_MENU) { //display a submenu
						c=0;
						do {	//do this b4 returning plz
							bulletsDestroy(bulls0[c]);
							bulletsDestroy(bulls1[c]);
						} while(menu[++c].sprite);
					menuSelect(menu[ndx].location,x,y,0);
					break;
				} else if(menu[ndx].type==MENU_EXIT) {
					menuClear();
					c=0;
					do {	//do this b4 returning plz
						bulletsDestroy(bulls0[c]);
						bulletsDestroy(bulls1[c]);
					} while(menu[++c].sprite);


					return(ndx);
				} else if(menu[ndx].type==MENU_FUNC) {
					c=0;
					do {	//do this b4 returning plz
						bulletsDestroy(bulls0[c]);
						bulletsDestroy(bulls1[c]);
					} while(menu[++c].sprite);
					((_pMENU)menu[ndx].location)(); //call a function
					break;
				}
			}
			if(Pad.Newpress.B) { //Press X to stop mod! (it gets annoying) :P
				PA_StopMod();
			}
			//math here makes me @_@ just dont get why one is -40 and the other -16 (-16 i expect but 40?!) 
			//40 related to spacing dunno just dunno 
			if((touchval=menuGetScreenY(y-40-192, (y-192-16)+((max+1)*32), 40))>=0) {
				ndx=touchval;

			}
			if(Pad.Newpress.Up || Pad.Newpress.Down || (touchval>=0)) {

//				PA_SetTextTileCol(0, TXTCOLR);
//				PA_OutputText(0, x, y+ndx, "%s  ",menu[ndx].name);
				bulletsSetAlpha(bulls0[ndx],1);	// turn on alpha 
				bulletsSetAlpha(bulls1[ndx],1);	// turn on alpha 
				PA_PlaySimpleSound(9, menuscroll);
				if(touchval<0) {
					if(Pad.Newpress.Up) {
						if(--ndx<0) ndx=max;
					} else {
						if(++ndx>max) ndx=0;
					}
				}
				bulletsSetAlpha(bulls0[ndx],0);	// turn on alpha 
				bulletsSetAlpha(bulls1[ndx],0);	// turn on alpha 
			}
		}
	}
}




/* This function will start the menu
   The basic system functions should already have been started 
   return value indicates like why it exited mebbe?
*/
char thMenu(void) {
//	int frame=0;	
	char result;
	PA_EasyBgLoad(1, 1, titlescreen);	//load top screen bg 
//	PA_EasyBgLoad(0, 2, menu_0bg2);	
//	PA_EasyBgLoad(0, 3, menu_0bg3);	
	PA_EasyBgLoad(0, 1, background);	//bottom menu screen bg (this should be the please watch warmy blah blah screen :D
//	PA_EasyBgLoad(1, 2, menu_1bg2);	
//	PA_EasyBgLoad(1, 3, menu_1bg2);	
	//create spinny thing for splash screen
//	while(Pad.Held.A) {};
	playSong(musicList,0);			//play main theme
	result=menuSelectGfx(menuMain,128-32,60,0);
//	PA_StopMod();
	PA_SetTextTileCol(0, TXTCOLR);
	PA_DeleteBg(0,1);
	PA_DeleteBg(1,1);
	return(result);	
}
